import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import { Badge, Box, IconButton, Menu, MenuItem } from "@mui/material";
import React, { useEffect, useState } from "react";
import FilterIcon from "@mui/icons-material/FilterList";
import DoneIcon from "@mui/icons-material/Done";
import { styled, experimental_sx as sx } from "@mui/system";

var LabelFilterMenu = function LabelFilterMenu(_ref) {
  var filterType = _ref.filterType,
      setFilterType = _ref.setFilterType;

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      anchorEl = _useState2[0],
      setAnchorEl = _useState2[1];

  var open = Boolean(anchorEl);
  var filterMenuItems = ["All", "Labeled", "Unlabeled"];

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  return React.createElement(Box, {
    sx: {
      ml: "auto",
      pointerEvents: "auto"
    }
  }, React.createElement(IconButton, {
    onClick: handleClick
  }, filterType !== 0 ? React.createElement(Badge, {
    color: "primary",
    variant: "dot"
  }, React.createElement(FilterIcon, {
    fontSize: "small"
  })) : React.createElement(FilterIcon, {
    fontSize: "small"
  })), React.createElement(Menu, {
    anchorOrigin: {
      vertical: "bottom",
      horizontal: "right"
    },
    transformOrigin: {
      vertical: "top",
      horizontal: "right"
    },
    anchorEl: anchorEl,
    open: open,
    onClose: handleClose,
    PaperProps: {
      style: {// backgroundColor: "#e9e9e9",
      }
    },
    MenuListProps: {
      style: {
        display: "flex",
        flexDirection: "column",
        flex: 1
      }
    }
  }, filterMenuItems.map(function (item, index) {
    return React.createElement(MenuItem, {
      sx: {
        display: "flex",
        alignItems: "center",
        gap: "10px",
        transition: "all 0.2s ease"
      },
      onClick: function onClick() {
        setFilterType(index);
        handleClose();
      }
    }, React.createElement(DoneIcon, {
      sx: {
        color: filterType !== index && "transparent",
        transition: "all 0.2s ease"
      },
      fontSize: "small"
    }), item);
  })));
};

export default LabelFilterMenu;